
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Pyroute2 netlink library &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Pyroute2" href="general.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="general.html" title="Pyroute2"
             accesskey="N">next</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="#">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="pyroute2-netlink-library">
<h1>Pyroute2 netlink library<a class="headerlink" href="#pyroute2-netlink-library" title="Permalink to this headline">¶</a></h1>
<div class="section" id="general-information">
<h2>General information<a class="headerlink" href="#general-information" title="Permalink to this headline">¶</a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="general.html">Pyroute2</a><ul>
<li class="toctree-l2"><a class="reference internal" href="general.html#supported-systems">Supported systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#ndb-high-level-rtnl-api">NDB – high level RTNL API</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#iproute-low-level-rtnl-api">IPRoute – Low level RTNL API</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#network-namespace-examples">Network namespace examples</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#installation">Installation</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#requirements">Requirements</a></li>
<li class="toctree-l2"><a class="reference internal" href="general.html#links">Links</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="makefile.html">Makefile documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-clean">target: clean</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-docs">target: docs</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-test">target: test</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-dist">target: dist</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-install">target: install</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#target-develop">target: develop</a></li>
<li class="toctree-l2"><a class="reference internal" href="makefile.html#other-targets">other targets</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="report.html">Report a bug</a></li>
</ul>
</div>
</div>
<div class="section" id="usage">
<h2>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="usage.html">Quickstart</a><ul>
<li class="toctree-l2"><a class="reference internal" href="usage.html#sockets">Sockets</a></li>
<li class="toctree-l2"><a class="reference internal" href="usage.html#resource-release">Resource release</a></li>
<li class="toctree-l2"><a class="reference internal" href="usage.html#imports">Imports</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="usage.html#special-cases">Special cases</a><ul>
<li class="toctree-l2"><a class="reference internal" href="usage.html#eventlet">eventlet</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="iproute.html">IPRoute module</a><ul>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#classes">Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#responses-as-lists">Responses as lists</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#module-pyroute2.iproute.bsd">BSD systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#module-pyroute2.iproute.windows">Windows systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#module-pyroute2.iproute.linux">Linux systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#module-pyroute2.netlink.rtnl.tcmsg.sched_drr">Queueing disciplines</a></li>
<li class="toctree-l2"><a class="reference internal" href="iproute.html#module-pyroute2.netlink.rtnl.tcmsg.cls_u32">Filters</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="remote.html">RemoteIPRoute</a><ul>
<li class="toctree-l2"><a class="reference internal" href="remote.html#caveats">Caveats</a></li>
<li class="toctree-l2"><a class="reference internal" href="remote.html#introduction">Introduction</a></li>
<li class="toctree-l2"><a class="reference internal" href="remote.html#indirect-access">Indirect access</a></li>
<li class="toctree-l2"><a class="reference internal" href="remote.html#run-with-privileges">Run with privileges</a></li>
<li class="toctree-l2"><a class="reference internal" href="remote.html#remote-network-namespaces">Remote network namespaces</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="ndb.html">NDB module</a><ul>
<li class="toctree-l2"><a class="reference internal" href="ndb.html#quick-start">Quick start</a></li>
<li class="toctree-l2"><a class="reference internal" href="ndb.html#reference">Reference</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="ipdb_toc.html">IPDB module</a><ul>
<li class="toctree-l2"><a class="reference internal" href="ipdb.html">IPDB guide</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="wiset.html">WiSet module</a></li>
<li class="toctree-l1"><a class="reference internal" href="ipset.html">IPSet module</a></li>
<li class="toctree-l1"><a class="reference internal" href="netns.html">NetNS module</a><ul>
<li class="toctree-l2"><a class="reference internal" href="netns.html#netns-management-overview">Netns management overview</a></li>
<li class="toctree-l2"><a class="reference internal" href="netns.html#netns-objects">NetNS objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="netns.html#nspopen">NSPopen</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="wireguard.html">WireGuard module</a></li>
</ul>
</div>
</div>
<div class="section" id="howtos">
<h2>Howtos<a class="headerlink" href="#howtos" title="Permalink to this headline">¶</a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="mpls.html">MPLS howto</a><ul>
<li class="toctree-l2"><a class="reference internal" href="mpls.html#mpls-labels">MPLS labels</a></li>
<li class="toctree-l2"><a class="reference internal" href="mpls.html#iproute">IPRoute</a></li>
<li class="toctree-l2"><a class="reference internal" href="mpls.html#ndb">NDB</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="debug.html">Netlink debug howto</a><ul>
<li class="toctree-l2"><a class="reference internal" href="debug.html#dump-data">Dump data</a></li>
<li class="toctree-l2"><a class="reference internal" href="debug.html#strace-compatibility-note">Strace compatibility note</a></li>
<li class="toctree-l2"><a class="reference internal" href="debug.html#decode-data">Decode data</a></li>
<li class="toctree-l2"><a class="reference internal" href="debug.html#compile-data">Compile data</a></li>
</ul>
</li>
</ul>
</div>
</div>
<div class="section" id="development">
<h2>Development<a class="headerlink" href="#development" title="Permalink to this headline">¶</a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="devcontribute.html">Project contribution guide</a><ul>
<li class="toctree-l2"><a class="reference internal" href="devcontribute.html#requirements">Requirements</a></li>
<li class="toctree-l2"><a class="reference internal" href="devcontribute.html#testing">Testing</a></li>
<li class="toctree-l2"><a class="reference internal" href="devcontribute.html#links">Links</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="arch.html">Module architecture</a><ul>
<li class="toctree-l2"><a class="reference internal" href="arch.html#sockets">Sockets</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch.html#netlink-messages">Netlink messages</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch.html#pf-route-messages">PF_ROUTE messages</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch.html#ipdb">IPDB</a></li>
<li class="toctree-l2"><a class="reference internal" href="arch.html#internet-protocols">Internet protocols</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="netlink.html">Netlink</a><ul>
<li class="toctree-l2"><a class="reference internal" href="netlink.html#basics">basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="netlink.html#pyroute2-and-netlink">pyroute2 and netlink</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="nlsocket.html">Base netlink socket and marshal</a><ul>
<li class="toctree-l2"><a class="reference internal" href="nlsocket.html#asynchronous-i-o">asynchronous I/O</a></li>
<li class="toctree-l2"><a class="reference internal" href="nlsocket.html#enobuf-and-async-i-o">ENOBUF and async I/O</a></li>
<li class="toctree-l2"><a class="reference internal" href="nlsocket.html#when-async-i-o-doesn-t-help">when async I/O doesn’t help</a></li>
<li class="toctree-l2"><a class="reference internal" href="nlsocket.html#classes">classes</a></li>
</ul>
</li>
</ul>
</div>
</div>
</div>
<div class="section" id="indices-and-tables">
<h1>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></p></li>
<li><p><a class="reference internal" href="py-modindex.html"><span class="std std-ref">Module Index</span></a></p></li>
<li><p><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></p></li>
</ul>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="#">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Pyroute2 netlink library</a><ul>
<li><a class="reference internal" href="#general-information">General information</a></li>
<li><a class="reference internal" href="#usage">Usage</a></li>
<li><a class="reference internal" href="#howtos">Howtos</a></li>
<li><a class="reference internal" href="#development">Development</a></li>
</ul>
</li>
<li><a class="reference internal" href="#indices-and-tables">Indices and tables</a></li>
</ul>

  <h4>Next topic</h4>
  <p class="topless"><a href="general.html"
                        title="next chapter">Pyroute2</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/index.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="general.html" title="Pyroute2"
             >next</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="#">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>